<?php
/*
	Copyright © Alexander Sunvas
	ICQ: 122255566, 854984
	URL: http://eleanor.su, http://eleanor-cms.ru, http://eleanor-cms.su
	E-mail: a@eleanor-cms.ru; sunvas@vingrad.ru
	=======================================
	Powered by Sunvas. Resale is forbidden!
*/

class TPLAdminPm
{
	/*
		Меню модуля
	*/
	protected static function Menu($act='')
	{
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		$links=&$GLOBALS['Eleanor']->module['links'];

		$options=isset($GLOBALS['Eleanor']->module['navigation']['options']) ? $GLOBALS['Eleanor']->module['navigation']['options'] : false;
		$GLOBALS['Eleanor']->module['navigation']=array(
			array($links['pms'],$lang['pms'],'act'=>$act=='pms'),
			array($links['letters'],$lang['letters'],'act'=>$act=='letters'),
			array($links['groups'],$lang['grights'],'act'=>$act=='groups'),
			$options ? $options : array($links['options'],Eleanor::$Language['main']['options'],'act'=>$act=='options'),
		);
	}

	/*
		Страница отображения диалогов
		$items - массив диалогов страниц. Формат: ID=>array(), ключи внутреннего массива:
			posts - количество постов в диалоге
			title - название диалога
			date - дата создания диалога
			lp_author - имя автора, оставившего последний пост в диалоге (безопасный HTML)
			lp_author_id - ID автора, оставившего последний пост в диалоге
			lp_date - дата последнего поста в диалоге
			hasattach - признак наличия в диалоге аттачей
			_senders - массив получателей диалога, содержит ID пользователей
			_owners - массив тех, кому доступен диалог, формат id=>array(), ключи внутреннего массива:
				_a - ссылка на просмотр диалога от имени пользователя
		$users - массив пользователей, формат id=>array(), ключи внутреннего массива:
			group - основная группа пользователя
			name - имя пользователя (небезопасный HTML)
		$groups - массив групп пользователей, формат id=>array(), ключи внутреннего массива:
			title - название группы
			html_pref - HTML префикс группы
			html_end - HTML окончание группы
		$cnt - количество диалогов всего
		$pp - количество диалогов на страницу
		$qs - массив параметров адресной строки для каждого запроса
		$page - номер текущей страницы, на которой мы сейчас находимся
		$links - перечень необходимых ссылок, массив с ключами:
			sort_name - ссылка на сортировку списка $items имени тега (возрастанию/убыванию в зависимости от текущей сортировки)
			sort_cnt - ссылка на сортировку списка $items количеству новостей (возрастанию/убыванию в зависимости от текущей сортировки)
			sort_id - ссылка на сортировку списка $items по ID (возрастанию/убыванию в зависимости от текущей сортировки)
			form_items - ссылка для параметра action формы, внутри которой происходит отображение перечня $items
			pp - фукнция-генератор ссылок на изменение количества диалогов отображаемых на странице
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
	*/
	public static function DialogsList($items,$users,$groups,$cnt,$pp,$qs,$page,$links)
	{
		static::Menu('pms');
		array_push($GLOBALS['jscripts'],'js/checkboxes.js','addons/autocomplete/jquery.autocomplete.js');
		$GLOBALS['head'][__class__.__function__]='<link rel="stylesheet" type="text/css" href="addons/autocomplete/style.css" />';
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
		$ltpl=Eleanor::$Language['tpl'];

		$qs+=array(''=>array());
		$qs['']+=array('fi'=>array());
		$fs=(bool)$qs['']['fi'];
		$qs['']['fi']+=array(
			'title'=>false,
			'titlet'=>false,
			'attach'=>false,
			'sender'=>false,
			'owner'=>false,
			'sfrom'=>false,
			'sto'=>false,
			'lfrom'=>false,
			'lto'=>false,
		);

		$Lst=Eleanor::LoadListTemplate('table-list',6)
			->begin(
				array($ltpl['title'],'sort'=>$qs['sort']=='title' ? $qs['so'] : false,'href'=>$links['sort_title']),
				array($lang['sent'],120,'sort'=>$qs['sort']=='date' ? $qs['so'] : false,'href'=>$links['sort_date']),
				$lang['wht'],
				array($lang['posts'],50,'sort'=>$qs['sort']=='posts' ? $qs['so'] : false,'href'=>$links['sort_posts']),
				array($lang['last'],120,'sort'=>$qs['sort']=='lp_date' ? $qs['so'] : false,'href'=>$links['sort_lp_date']),
				array(Eleanor::Check('mass',false,array('id'=>'mass-check')),20)
			);

		if($items)
			foreach($items as $k=>&$v)
			{
				$talking='';
				foreach($v['_owners'] as $ok=>&$ov)
					if(isset($users[$ok]))
					{
						$gr=isset($groups[$users[$ok]['_group']]) ? $groups[$users[$ok]['_group']] : false;
						$talking.='<a href="'.$ov['_a'].'" target="_blank"'.($gr ? ' title="'.$gr['_title'].'"' : '').'>'.($gr ? $gr['html_pref'] : '').htmlspecialchars($users[$ok]['name'],ELENT,CHARSET).($gr ? $gr['html_end'] : '').'</a>'.(in_array($ok,$v['_senders']) ? '&rarr;' : '').', ';
					}
				$last=$v['lp_author_id'];
				if(isset($users[$last]))
				{
					$gr=isset($groups[$users[$last]['_group']]) ? $groups[$users[$last]['_group']] : false;
					$last='<a href="'.Eleanor::$Login->UserLink($users[$last]['name'],$last).'"'.($gr ? ' title="'.$gr['_title'].'"' : '').'>'.($gr ? $gr['html_pref'] : '').htmlspecialchars($users[$last]['name'],ELENT,CHARSET).($gr ? $gr['html_end'] : '').'</a>';
				}
				else
					$last=$v['lp_author'];
				$Lst->item(
					($v['hasattach'] ? ' <img src="images/pm/attach.png" alt="" /> ' : '').$v['title'],
					array(Eleanor::$Language->Date($v['date'],'fdt'),'center'),
					$talking ? rtrim($talking,', ') : '&mdash;',
					array($v['posts'],'right'),
					array($last.'<br />'.Eleanor::$Language->Date($v['lp_date'],'fdt'),'center'),
					Eleanor::Check('mass[]',false,array('value'=>$k))
				);
			}
		else
			$Lst->empty($lang['dnf']);

		$temp=array(
			'b'=>$lang['b'],
			'q'=>$lang['m'],
			'e'=>$lang['e'],
			'm'=>$lang['c'],
		);
		$fititlet='';
		foreach($temp as $k=>&$v)
			$fititlet.=Eleanor::Option($v,$k,$qs['']['fi']['titlet']==$k);

		return Eleanor::$Template->Cover('<form method="post">
			<table class="tabstyle tabform" id="ftable">
				<tr class="infolabel"><td colspan="2"><a href="#">'.$lang['filters'].'</a></td></tr>
				<tr>
					<td><b>'.$ltpl['title'].'</b><br />'.Eleanor::Select('fi[titlet]',$fititlet,array('style'=>'width:30%')).Eleanor::Input('fi[title]',$qs['']['fi']['title'],array('style'=>'width:68%')).'</td>
					<td><b>'.$lang['attaches'].'</b><br />'.Eleanor::Select('fi[attach]',Eleanor::Option($lang['ni'],'-',$qs['']['fi']['attach']===false).Eleanor::Option($lang['y'],'-',$qs['']['fi']['attach']).Eleanor::Option($lang['n'],'-',!$qs['']['fi']['attach']),array('style'=>'width:100%')).'</td>
				</tr>
				<tr>
					<td><b>'.$lang['sender'].'</b><br />'.Eleanor::Input('fi[sender]',$qs['']['fi']['sender']).'</td>
					<td><b>'.$lang['participant'].'</b><br />'.Eleanor::Input('fi[owner]',$qs['']['fi']['owner']).'</td>
				</tr>
				<tr>
					<td><b>'.$lang['ds'].'</b> '.$lang['ft'].'<br />'.Dates::Calendar('fi[sfrom]',$qs['']['fi']['sfrom'],true,array('style'=>'width:35%')).' - '.Dates::Calendar('fi[sto]',$qs['']['fi']['sto'],true,array('style'=>'width:35%')).'</td>
					<td><b>'.$lang['dl'].'</b> '.$lang['ft'].'<br />'.Dates::Calendar('fi[lfrom]',$qs['']['fi']['lfrom'],true,array('style'=>'width:35%')).' - '.Dates::Calendar('fi[lto]',$qs['']['fi']['lto'],true,array('style'=>'width:35%')).'</td>
				</tr>
				<tr>
					<td colspan="2" style="text-align:center;vertical-align:middle">'.Eleanor::Button($ltpl['apply']).'</td>
				</tr>
			</table>
<script type="text/javascript">//<![CDATA[
$(function(){
	var fitrs=$("#ftable tr:not(.infolabel)");
	$("#ftable .infolabel a").click(function(){
		fitrs.toggle();
		$("#ftable .infolabel a").toggleClass("selected");
		return false;
	})'.($fs ? '' : '.click()').';

	$("[name=\"fi[sender]\"]").autocomplete({
		serviceUrl:CORE.ajax_file,
		minChars:2,
		delimiter:/,\s*/,
		params:{
			module:"'.$GLOBALS['Eleanor']->module['name'].'",
			event:"completeuser"
		}
	});
	$("[name=\"fi[owner]\"]").autocomplete({
		serviceUrl:CORE.ajax_file,
		minChars:2,
		delimiter:null,
		params:{
			module:"'.$GLOBALS['Eleanor']->module['name'].'",
			event:"completeuser"
		}
	});
	One2AllCheckboxes("#checks-form","#mass-check","[name=\"mass[]\"]",true);
});//]]></script>
		</form><form id="checks-form" action="'.$links['form_items'].'" method="post" onsubmit="return (CheckGroup(this) && confirm(\''.$ltpl['are_you_sure'].'\'))">'
		.$Lst->end().'<div class="submitline" style="text-align:right"><div style="float:left">'.sprintf($lang['dpp'],$Lst->perpage($pp,$links['pp'])).'</div>'.$ltpl['with_selected'].Eleanor::Select('op',Eleanor::Option($ltpl['delete'],'k')).Eleanor::Button('Ok').'</div></form>'
		.Eleanor::$Template->Pages($cnt,$pp,$page,array($links['pages'],$links['first_page'])));
	}

	/*
		Страница отображения всех групп пользователей
		$items - массив групп пользователей. Формат: ID=>array(), ключи внутреннего массива (если какое-то значение равно null, значит свойство наследуется):
			_title - название группы
			html_pref - HTML префикс группы
			html_end - HTML суффикс группы
			on - флаг включения группе возможности пользования диалогами
			maxdialogs - максимум диалогов
			maxinvates - максимум приглашений пользователей
			_aedit - ссылка на редактирование группы
			_aparent - ссылка на просмотр подгрупп
		$subitems - массив подгрупп для групп из массива $items. Формат: ID=>array(id=>array(), ...), где ID - идентификатор группы, id - идентификатор подгруппы. Ключи массива подгруппы:
			title - название подгруппы
			_aedit - ссылка на редактирование подгруппы
		$parents - массив родителей для возможности получения значений параметров, которые наследуются. Формат: ID=>array(id=>array(), ...), ключи внутреннего массива:
			on - флаг включения группе возможности пользования диалогами
			maxdialogs - максимум диалогов
			maxinvates - максимум приглашений пользователей
		$navi - массив, хлебные крошки навигации. Формат ID=>array(), ключи:
			title - заголовок крошки
			_a - ссылка подпункта данной крошки. Может быть равно false
	*/
	public static function Groups($items,$subitems,$parents,$navi)
	{
		static::Menu('groups');
		$ltpl=Eleanor::$Language['tpl'];
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];

		$nav=array();
		foreach($navi as &$v)
			$nav[]=$v['_a'] ? '<a href="'.$v['_a'].'">'.$v['title'].'</a>' : $v['title'];

		$Lst=Eleanor::LoadListTemplate('table-list',5)
			->begin($lang['group'],$lang['msd'],$lang['msi'],$ltpl['functs']);

		if($items)
		{
			$editimg=Eleanor::$Template->default['theme'].'images/edit.png';
			foreach($items as $k=>&$v)
			{
				$subs='';
				if(isset($subitems[$k]))
					foreach($subitems[$k] as $kk=>&$vv)
						$subs.='<a href="'.$vv['_aedit'].'">'.$vv['title'].'</a>, ';

				foreach($v['parents'] as &$p)
				{
					if($v['maxdialogs']===null and isset($parents[$p]['maxdialogs']))
						$v['maxdialogs']=$parents[$p]['maxdialogs'];
					if($v['maxinvates']===null and isset($parents[$p]['maxinvates']))
						$v['maxinvates']=$parents[$p]['maxinvates'];
					if($v['on']===null and isset($parents[$p]['on']))
						$v['on']=$parents[$p]['on'];
				}

				$v['maxdialogs']=(int)$v['maxdialogs'];
				$v['maxinvates']=(int)$v['maxinvates'];
				if($v['on']===null)
					$v['on']=1;

				$Lst->item(
					array($v['html_pref'].$v['_title'].$v['html_end'].($subs ? '<br /><span class="small"><a href="'.$v['_aparent'].'" style="font-weight:bold">'.$lang['sgs'].'</a>: '.rtrim($subs,', ').'</span>' : ''),'href'=>$v['_aedit']),
					array($v['on'] ? ($v['maxdialogs']==0 ? '&infin;' : $v['maxdialogs']) : '&empty;',$v['maxdialogs']>0 && $v['on'] ? 'right' : 'center'),
					array($v['on'] ? ($v['maxinvates']==0 ? '&infin;' : $v['maxinvates']) : '&empty;',$v['maxinvates']>0 && $v['on'] ? 'right' : 'center'),
					$Lst('func',
						array($v['_aedit'],$ltpl['edit'],$editimg)
					)
				);
			}
		}
		else
			$Lst->empty($lang['gsnf']);
		return Eleanor::$Template->Cover(($nav ? '<table class="filtertable"><tr><td style="font-weight:bold">'.join(' &raquo; ',$nav).'</td></tr></table>' : '').$Lst->end());
	}

	/*
		Страница редактирования настроек группы
		$garr - массив системных значений группы, ключи:
			id - идентификатор группы
			parents - строка, определяющая родителей группы
			_title - название группы
			html_pref - HTML префикс группы
			html_end  - HTML окончание группы
		$values - массив значений, ключи:
			on - флаг включения группе возможности пользования диалогами
			maxdialogs - максимум диалогов
			maxinvates - максимум приглашений пользователей
			editlimit - временной лимит редактирования сообщения
		$errors - массив ошибок
		$back - URL возврата
	*/
	public static function EditGroup($garr,$values,$back,$errors)
	{
		$inh=(bool)$garr['parents'];
		$Lst=Eleanor::LoadListTemplate('table-form');
		$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];

		if($back)
			$back=Eleanor::Input('back',$back,array('type'=>'hidden'));

		return Eleanor::$Template->Cover(
			$Lst->form()
			->begin(array('id'=>'tg'))
			->item(array($lang['pmon'].($inh ? Eleanor::Check('inherit[]',!isset($values['on']),array('style'=>'display:none','value'=>'on')) : ''),($inh ? '<div>' : '').Eleanor::Check('on',$values['on']).($inh ? '</div>' : '')))
			->item(array(
				$lang['md'].($inh ? Eleanor::Check('inherit[]',!isset($values['maxdialogs']),array('style'=>'display:none','value'=>'maxdialogs')) : ''),($inh ? '<div>' : '').Eleanor::Input('maxdialogs',$values['maxdialogs'],array('type'=>'number','min'=>0)).($inh ? '</div>' : ''),
				'descr'=>$lang['md_'],
			))
			->item(array(
				$lang['mi'].($inh ? Eleanor::Check('inherit[]',!isset($values['maxinvates']),array('style'=>'display:none','value'=>'maxinvates')) : ''),($inh ? '<div>' : '').Eleanor::Input('maxinvates',$values['maxinvates'],array('type'=>'number','min'=>0)).($inh ? '</div>' : ''),
				'descr'=>$lang['mi_'],
			))
			->item(array(
				$lang['el'].($inh ? Eleanor::Check('inherit[]',!isset($values['editlimit']),array('style'=>'display:none','value'=>'editlimit')) : ''),($inh ? '<div>' : '').Eleanor::Input('editlimit',$values['editlimit'],array('type'=>'number','min'=>0)).($inh ? '</div>' : ''),
				'descr'=>$lang['el_'],
			))
			->button($back.Eleanor::Button('OK'))
			->end()
			->endform(),
			$errors
		).($inh ? '<script type="text/javascript">//<![CDATA[
$(function(){
	var Check=function(ftd,state)
	{
		var ch=$(ftd).find(":checkbox");
		if(typeof state=="undefined")
			state=!ch.prop("checked");
		if(state)
			ch.end().css("text-decoration","line-through").prop("title","'.$lang['inherits'].'").next().children("div").hide();
		else
			ch.end().css("text-decoration","").prop("title","").next().children("div").show();
		ch.prop("checked",state)
	}
	$("#tg tr").find("td:first").filter(function(){
		return $(this).has(":checkbox").size()>0;
	}).click(function(){
		Check(this);
	}).each(function(){
		Check(this,$(":checkbox",this).prop("checked"));
	}).css("cursor","pointer");});//]]></script>' : '');
	}

	/*
		Страница правки форматов писем
		$controls - перечень контролов в соответствии с классом контролов. Если какой-то элемент массива не является массивом, значит это заголовок подгруппы контролов
		$values - результирующий HTML код контролов, который необходимо вывести на странице. Ключи данного массива совпадают с ключами $controls
		$errors - массив ошибок
	*/
	public static function Letters($controls,$values,$errors)
	{
		static::Menu('letters');
		$Lst=Eleanor::LoadListTemplate('table-form')->form()->begin();
		foreach($controls as $k=>&$v)
			if(is_array($v))
				$Lst->item(array($v['title'],Eleanor::$Template->LangEdit($values[$k],null),'tip'=>$v['descr']));
			else
				$Lst->head($v);
		$Lst->button(Eleanor::Button())->end()->endform();

		if($errors)
		{
			$lang=Eleanor::$Language[$GLOBALS['Eleanor']->module['config']['n']];
			foreach($errors as $k=>&$v)
				if(is_int($k) and isset($lang[$v]))
					$v=$lang[$v];
		}
		return Eleanor::$Template->Cover((string)$Lst,$errors);
	}

	/*
		Обертка для настроек
		$c - интерфейс настроек
	*/
	public static function Options($c)
	{
		static::Menu('options');
		return$c;
	}
}