<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym
*/
class ApiPm extends BaseClass
{
	private
		$config=array();

	public function __construct(array$config=array())
	{
		$this->config=$config ? $config : include dirname(__file__).'/config.php';
	}

	public function DeleteUser($ids)
	{
		$in=Eleanor::$Db->In($ids);
		$tids=$ntids=array();
		$R=Eleanor::$Db->Query('SELECT `tid` FROM `'.$this->config['pd'].'` WHERE `owner`'.$in);
		while($a=$R->fetch_assoc())
			$tids[]=$a['tid'];
		if(!$tids)
			return;
		$tin=Eleanor::$Db->In($tids);
		Eleanor::$Db->Delete($this->config['pd'],'`owner`'.$tin);
		if($tids)
		{
			$R=Eleanor::$Db->Query('SELECT `tid` FROM `'.$this->config['pd'].'` WHERE `tid`'.Eleanor::$Db->In($tids));
			while($a=$R->fetch_assoc())
				$ntids[]=$a['tid'];
			if($ntids)
			{
				$tids=array_diff($tids,$ntids);
				$tin=Eleanor::$Db->In($tids);
			}
		}
		foreach($tids as &$v)
			Files::Delete(Eleanor::$root.Eleanor::$uploads.DIRECTORY_SEPARATOR.$this->config['n'].DIRECTORY_SEPARATOR.$v);
		Eleanor::$Db->Delete($this->config['pp'],'`tid`'.$tin);
		Eleanor::$Db->Delete($this->config['pt'],'`id`'.$tin);
	}

	public function SyncGroups()
	{
		#Не думаю, что есть смысл считать сколько всего сделано, но пусть будет
		$res=array(
			'done'=>0,#Сделано
			'total'=>0,#Всего
		);

		$toins=$todel=array();
		$R=Eleanor::$Db->Query('SELECT `g`.`id` FROM `'.P.'groups` `g` LEFT JOIN `'.$this->config['pg'].'` `f` USING (`id`) WHERE `f`.`id` IS NULL');
		while($t=$R->fetch_row())
			$toins[]=$t[0];
		$R=Eleanor::$Db->Query('SELECT `f`.`id` FROM `'.$this->config['pg'].'` `f` LEFT JOIN `'.P.'groups` `g` USING (`id`) WHERE `g`.`id` IS NULL');
		while($t=$R->fetch_row())
			$todel[]=$t[0];
		if($toins)
			Eleanor::$Db->Insert($this->config['pg'],array('id'=>$toins));
		if($todel)
			Eleanor::$Db->Delete($this->config['pg'],'`id`'.Eleanor::$Db->In($todel));

		$res['done']=$res['total']=count($todel)+count($toins);
		return$res;
	}

	public function SendRegLetter($ids,$isuids=true)
	{
		if($isuids)
		{
			$R=Eleanor::$Db->Query('SELECT `id`,`email`,`name`,`language` FROM `'.P.'users_site` WHERE `id`'.Eleanor::$Db->In($ids));
			$ids=array();
			while($a=$R->fetch_assoc())
			{
				$a['_sname']=htmlspecialchars($a['name'],ELENT,CHARSET);
				$ids[$a['id']]=array_slice($a,1);
			}
		}
		$l=array();
		$upref=PROTOCOL.Eleanor::$punycode.Eleanor::$site_path;
		$melink=false;
		foreach($ids as $k=>&$v)
		{
			$lang=$v['language'] && Eleanor::$langs[$v['language']] ? $v['language'] : LANGUAGE;
			if(!isset($l[$lang]))
				$l[$lang]=include dirname(__file__).'/letters-'.$lang.'.php';

			if(!$l[$lang]['user'][0] or !$l[$lang]['newpm_t'] or !$l[$lang]['newpm'])
				continue;

			if(!$melink)
				$melink=$upref.Eleanor::$Login->UserLink(htmlspecialchars_decode($l[$lang]['user'][0],ELENT),$l[$lang]['user'][1]);

			$repl=array(
				'from'=>$l[$lang]['user'][0],
				'froml'=>$melink,
				'site'=>Eleanor::$vars['site_name'],
				'link'=>$upref,
				'name'=>$v['_sname'],
			);

			$topic=array(
				'title'=>Eleanor::ExecBBLogic($l[$lang]['reg_t'],$repl),
				'date'=>date('Y-m-d H:i:s'),
				'lp_author'=>$l[$lang]['user'][0],
				'lp_author_id'=>$l[$lang]['user'][1],
			);
			$topic['id']=Eleanor::$Db->Insert($this->config['pt'],$topic+array('lp_date'=>$topic['date']));
			$pid=Eleanor::$Db->Insert(
				$this->config['pp'],
				array(
					'date'=>$topic['date'],
					'tid'=>$topic['id'],
					'author'=>$topic['lp_author'],
					'author_id'=>$topic['lp_author_id'],
					'text'=>Eleanor::ExecBBLogic($l[$lang]['reg'],$repl),
				)
			);
			Eleanor::$Db->Update($this->config['pt'],array('lp_id'=>$pid),'`id`='.$topic['id'].' LIMIT 1');
			$diid=Eleanor::$Db->Insert($this->config['pd'],array(
				'owner'=>$k,
				'from'=>$topic['lp_author_id'],
				'sent'=>1,
				'tid'=>$topic['id'],
				'lp_date'=>$topic['date'],
				'caninvate'=>1,
				'canpermit'=>1,
				'status'=>1,
			));

			if(isset($v['email']))
			{
				$repl+=array(
					'title'=>$topic['title'],
					'linkpm'=>$upref.$GLOBALS['Eleanor']->Url->Construct(array('do'=>'findpost','d'=>$diid,'p'=>$pid)),
				);
				Email::Simple(
					$v['email'],
					Eleanor::ExecBBLogic($l[$lang]['newpm_t'],$repl),
					Eleanor::ExecBBLogic($l[$lang]['newpm'],$repl)
				);
			}
		}
	}

	/*
		$ids - ИДы
		$isuids -  признак того, что в переменной $ids содержатся только IDы пользователей.
	*/
	public function GetUsersMaxDialogs($ids,$isuids=true)
	{
		if($isuids)
		{
			$R=Eleanor::$Db->Query('SELECT `id`,`groups` FROM `'.P.'users_site` WHERE `id`'.Eleanor::$Db->In($ids));
			$ids=array();
			while($a=$R->fetch_assoc())
				$ids[$a['id']]['groups']=explode(',,',trim($a['groups'],','));
		}
		$r=array();
		foreach($ids as $k=>&$v)
		{
			$m=Eleanor::Permissions($v['groups'],'on',$this->config['pg']);
			$r[$k]['on']=in_array(1,$m);

			if($r[$k]['on'])
			{
				$m=Eleanor::Permissions($v['groups'],'maxdialogs',$this->config['pg']);
				$r[$k]['maxdialogs']=in_array(0,$m) ? 0 : max($m);

				$m=Eleanor::Permissions($v['groups'],'maxinvates',$this->config['pg']);
				$r[$k]['maxinvates']=in_array(0,$m) ? 0 : max($m);

				$m=Eleanor::Permissions($v['groups'],'editlimit',$this->config['pg']);
				$r[$k]['editlimit']=in_array(0,$m) ? 0 : max($m);
			}
			else
				$r[$k]['maxdialogs']=$r[$k]['maxinvates']=$r[$k]['editlimit']=false;
		}
		return$r;
	}
}